##############################################################################
# Construction de la fenetre .topcheckup
##############################################################################

# procedure to show window ShowWindow.topcheckup
proc ShowWindow.topcheckup { args} {
    # xf ignore me 7
    
    # build widget .topcheckup
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topcheckup"
    } {
	catch "destroy .topcheckup"
    }
    toplevel .topcheckup \
	-relief {raised}
    
    # Window manager configurations
    wm positionfrom .topcheckup program
    wm sizefrom .topcheckup program
    wm geometry .topcheckup 250x44
    wm minsize .topcheckup 10 10
    wm title .topcheckup {daTac: Check-up}

    global {font1}

    # bindings
    bind .topcheckup <Enter> {focus .topcheckup.f.e}

    # build widget .topcheckup.bCancel
    button .topcheckup.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .topcheckup} \
	-cursor {circle} \
	-text {Cancel}

    # build widget .topcheckup.bNone
    button .topcheckup.bNone \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreeCheckUp ""
	    .topcheckup.bOk invoke} \
	-cursor {hand2} \
	-text {None}

    # build widget .topcheckup.bOk
    button .topcheckup.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    set entreeCheckUp [string trim $entreeCheckUp]
	    if {$entreeCheckUp == ""} {
		set varCheckUp 0
		.menubar.mbexecution.m entryconfigure 7 \
		    -label "No periodical check-up"
		.menubar.mbexecution.m entryconfigure 8 -state disabled
		DestroyWindow .topcheckup
	    } elseif {[regexp {^([0-9]*)$} $entreeCheckUp] == 1 \
			  && $entreeCheckUp > 0} {
		set varCheckUp $entreeCheckUp
		.menubar.mbexecution.m entryconfigure 7 \
		    -label "Check-up every $varCheckUp clauses"
		.menubar.mbexecution.m entryconfigure 8 -state active
		DestroyWindow .topcheckup
	    } else {
		ShowWindow.topmessage
		.topmessage.msg configure -text "\n\nCheck-up:\n\nPositive integer or Nothing expected\n\nand got: \"$entreeCheckUp\".\n\n"
	    }
	} \
	-cursor {hand1} \
	-text {Ok}
    
    # build widget .topcheckup.f
    frame .topcheckup.f \
	-relief {raised}
    
    # build widget .topcheckup.f.e
    entry .topcheckup.f.e \
	-font $font1 \
	-relief {sunken} \
	-textvariable {entreeCheckUp}
    
    # bindings
    bind .topcheckup.f.e <Key-Return> {
	.topcheckup.bOk flash
	.topcheckup.bOk invoke
    }
    
    # build widget .topcheckup.f.lbl
    label .topcheckup.f.lbl \
	-font $font1 \
	-bg {grey80} \
	-padx {2} \
	-relief {flat} \
	-text {Value:}
    
    # pack widget .topcheckup.f
    pack append .topcheckup.f \
	.topcheckup.f.lbl {left frame center} \
	.topcheckup.f.e {top frame center expand fill} 
    
    # pack widget .topcheckup
    pack append .topcheckup \
	.topcheckup.f {top frame center fill} \
	.topcheckup.bNone {left frame center expand fill} \
	.topcheckup.bCancel {left frame center expand fill} \
	.topcheckup.bOk {left frame center expand fill} 
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .topcheckup"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
