######################################################################
# Construction de la fenetre .topexec$i
######################################################################

# Procedure: BuildExecutionAutomaticWindow 
proc BuildExecutionAutomaticWindow { i msg } {
    # Construction d'une fenetre #i dans laquelle on va executer rdatac en mode automatic
    
    # build widget .topexec$i
    toplevel .topexec$i 
    
    # Window manager configurations
    global {font1}
    global {font2}
    wm positionfrom .topexec$i ""
    wm sizefrom .topexec$i ""
    wm minsize .topexec$i 10 10
    wm title .topexec$i [list daTac: Automatic Execution \#$i]
    
    # build widget .topexec$i.lbl
    label .topexec$i.lbl \
	-font $font1 \
	-bg {grey80} \
	-text [concat "Automatic" $msg]
    
    # build widget .topexec$i.bStopOk
    button .topexec$i.bStopOk \
	-command [list ExecAutoButtonStop $i] \
	-cursor {pirate} \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Stop}
    
    global pauseExec
    set pauseExec($i) 0
    
    # build widget .topexec$i.checkbuttonpause
    checkbutton .topexec$i.checkbuttonpause \
	-cursor {clock} \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Pause} \
	-variable [list pauseExec($i)]
    
    # build widget .topexec$i.ftext
    frame .topexec$i.ftext \
	-relief {raised}
    
    # build widget .topexec$i.ftext.sy
    scrollbar .topexec$i.ftext.sy \
	-command ".topexec$i.ftext.text yview" \
	-relief {raised}
    
    # build widget .topexec$i.ftext.text
    text .topexec$i.ftext.text \
	-borderwidth {2} \
	-relief {raised} \
	-height {20} \
	-font $font2 \
	-wrap {char} \
	-yscroll ".topexec$i.ftext.sy set"
    # bindings
    bind .topexec$i.ftext.text <Any-Key> {NoFunction}
    
    # pack widget .topexec$i.ftext
    pack append .topexec$i.ftext \
	.topexec$i.ftext.sy {left frame center filly} \
	.topexec$i.ftext.text {top frame center expand fill} 
    
    # pack widget .topexec$i
    pack append .topexec$i \
	.topexec$i.lbl {top frame center fill} \
	.topexec$i.ftext {top frame center expand fill} \
	.topexec$i.checkbuttonpause {left frame center expand fill} \
	.topexec$i.bStopOk {left frame center expand fill} 
}

# Procedure: ChangeExecutionAutomaticWindow 
proc ChangeExecutionAutomaticWindow { i } {
    
    global {font1}

    # build widget .topexec$i.bInf
    button .topexec$i.bInf \
	-command [list ExecButtonStat $i "Automatic"] \
	-cursor {hand2} \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Statistics Window}
    
    global pauseExec
    set pauseExec($i) 0
    
    # pack widget .topexec$i
    pack forget .topexec$i.checkbuttonpause
    pack append .topexec$i \
	.topexec$i.lbl {top frame center fill} \
	.topexec$i.ftext {top frame center expand fill} \
	.topexec$i.bInf {left frame center expand fill} \
	.topexec$i.bStopOk {left frame center expand fill}
    
    .topexec$i.bStopOk configure -text {Ok} -cursor {hand1} -command [list ExecButtonOk $i]
}


######################################################################
# Construction de la fenetre .topexec$i
######################################################################

# Procedure: BuildExecutionManualWindow 
proc BuildExecutionManualWindow { i msg ps } {
    # Construction d'une fenetre #i dans laquelle on va executer rdatac en mode manuel
    
    global {font1}
    global {font2}

    # build widget .topexec$i
    toplevel .topexec$i 
    
    # Window manager configurations
    wm positionfrom .topexec$i ""
    wm sizefrom .topexec$i ""
    wm minsize .topexec$i 10 10
    wm title .topexec$i [list daTac: Manual Execution \#$i]
    
    # build widget .topexec$i.lbl
    label .topexec$i.lbl \
	-font $font1 \
	-bg {grey80} \
	-text [concat "Manual Execution with Strategies:" $msg $ps]
    
    # build widget .topexec$i.bStopOk
    button .topexec$i.bStopOk \
	-command [list ExecManButtonStop $i] \
	-cursor {pirate} \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Stop}
    
    # build widget .topexec$i.bInf
    button .topexec$i.bInf \
	-command [list ExecManButtonInf $i $ps] \
	-cursor {hand2} \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-text {Inference Window}
    
    # build widget .topexec$i.ftext
    frame .topexec$i.ftext \
	-relief {raised}
    
    # build widget .topexec$i.ftext.sy
    scrollbar .topexec$i.ftext.sy \
	-command [list .topexec$i.ftext.text yview] \
	-relief {raised}
    
    # build widget .topexec$i.ftext.text
    text .topexec$i.ftext.text \
	-borderwidth {2} \
	-relief {raised} \
	-height {20} \
	-font $font2 \
	-wrap {char} \
	-yscrollcommand [list .topexec$i.ftext.sy set]
    # bindings
    bind .topexec$i.ftext.text <Any-Key> {NoFunction}
    
    # pack widget .topexec$i.ftext
    pack append .topexec$i.ftext \
	.topexec$i.ftext.sy {left frame center filly} \
	.topexec$i.ftext.text {top frame center expand fill} 
    
    # pack widget .topexec$i
    pack append .topexec$i \
	.topexec$i.lbl {top frame center fill} \
	.topexec$i.ftext {top frame center expand fill} \
	.topexec$i.bInf {left frame center expand fill} \
	.topexec$i.bStopOk {left frame center expand fill} 
}


######################################################################
# Procedure: BuildExecInfWindow 
proc BuildExecInfWindow  { i ps t} {
    # Construction d'une fenetre #i servant a entrer les inferences a executer
    
    # build widget .topexecinf$i
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topexecinf$i"
    } {
	catch "destroy .topexecinf$i"
    }

    # build widget .topexecinf$i
    toplevel .topexecinf$i 

    # Window manager configurations
    wm positionfrom .topexecinf$i ""
    wm sizefrom .topexecinf$i ""
    wm maxsize .topexecinf$i 1000 1000
    wm minsize .topexecinf$i 10 10
    wm title .topexecinf$i $t
    
    global font1
    
    # build widget .topexecinf$i.bClose
    button .topexecinf$i.bClose \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list destroy .topexecinf$i] \
	-cursor {hand1} \
	-text {Close}
    
    # build widget .topexecinf$i.f0
    frame .topexecinf$i.f0 \
	-relief {flat}
    
    # build widget .topexecinf$i.f0.inf
    radiobutton .topexecinf$i.f0.inf \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-value {1} \
	-text {Inferences} \
	-relief {flat} \
	-variable [list varTypeManDed($i)] \
	-command [list ChangeInfWindow $i]
    
    # build widget .topexecinf$i.f0.simpl
    radiobutton .topexecinf$i.f0.simpl \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-value {2} \
	-text {Simplifications} \
	-relief {flat} \
	-variable [list varTypeManDed($i)] \
	-command [list ChangeInfWindow $i]
    
    # build widget .topexecinf$i.f0.stat
    radiobutton .topexecinf$i.f0.stat \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-value {3} \
	-text {Statistics} \
	-relief {flat} \
	-variable [list varTypeManDed($i)] \
	-command [list ChangeInfWindow $i]
    
    # pack widget .topexecinf$i.f0
    pack append .topexecinf$i.f0 \
	.topexecinf$i.f0.inf {left frame center expand fillx} \
	.topexecinf$i.f0.simpl {left frame center expand fillx} \
	.topexecinf$i.f0.stat {left frame center expand fillx}
    
    
    # build widget .topexecinf$i.fb
    frame .topexecinf$i.fb

    # build widget .topexecinf$i.fb.finf1
    frame .topexecinf$i.fb.finf1 \
	-borderwidth {2} \
	-relief {flat}
    
    # build widget .topexecinf$i.fb.finf1.lp
    button .topexecinf$i.fb.finf1.lp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "lp" "Left $ps from" "into"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Left $ps "
    
    # build widget .topexecinf$i.fb.finf1.clp
    button .topexecinf$i.fb.finf1.clp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "clp" "Contextual Left $ps from" "into"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Contextual Left $ps "
    
    # build widget .topexecinf$i.fb.finf1.ref
    button .topexecinf$i.fb.finf1.ref \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "ref" "Reflexion of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Reflexion "
    
    # build widget .topexecinf$i.fb.finf1.res
    button .topexecinf$i.fb.finf1.res \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "res" "Resolution between" "and"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Resolution "
    
    # build widget .topexecinf$i.fb.finf1.ef
    button .topexecinf$i.fb.finf1.ef \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "ef" "Equational Factoring of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text "Equational Factoring"
    
    # pack widget .topexecinf$i.fb.finf1
    pack append .topexecinf$i.fb.finf1 \
	.topexecinf$i.fb.finf1.lp {top frame center fillx} \
	.topexecinf$i.fb.finf1.clp {top frame center fillx} \
	.topexecinf$i.fb.finf1.ref {top frame center fillx} \
	.topexecinf$i.fb.finf1.res {top frame center fillx} \
	.topexecinf$i.fb.finf1.ef {top frame center fillx}
    
    
    # build widget .topexecinf$i.fb.finf2
    frame .topexecinf$i.fb.finf2 \
	-borderwidth {2} \
	-relief {flat}
    
    # build widget .topexecinf$i.fb.finf2.rp
    button .topexecinf$i.fb.finf2.rp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "rp" "Right $ps from" "into"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Right $ps "
    
    # build widget .topexecinf$i.fb.finf2.crp
    button .topexecinf$i.fb.finf2.crp \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "crp" "Contextual Right $ps from" "into"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Contextual Right $ps "
    
    # build widget .topexecinf$i.fb.finf2.ep
    button .topexecinf$i.fb.finf2.ep \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "ep" "Extended $ps between" "and"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Extended $ps "
    
    # build widget .topexecinf$i.fb.finf2.f
    button .topexecinf$i.fb.finf2.f \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "f" "Factoring of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Factoring "
    
    # build widget .topexecinf$i.fb.finf2.norm
    button .topexecinf$i.fb.finf2.norm \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "norm" "Normalisation of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Normalisation "
    
    # pack widget .topexecinf$i.fb.finf2
    pack append .topexecinf$i.fb.finf2 \
	.topexecinf$i.fb.finf2.rp {top frame center fillx} \
	.topexecinf$i.fb.finf2.crp {top frame center fillx} \
	.topexecinf$i.fb.finf2.ep {top frame center fillx} \
	.topexecinf$i.fb.finf2.f {top frame center fillx} \
	.topexecinf$i.fb.finf2.norm {top frame center fillx}
    
    
    # build widget .topexecinf$i.fb.fsimpl1
    frame .topexecinf$i.fb.fsimpl1 \
	-borderwidth {2} \
	-relief {flat}
    
    # build widget .topexecinf$i.fb.fsimpl1.s
    button .topexecinf$i.fb.fsimpl1.s \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "s" "Simplification from" "into"] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Simplification "
    
    # build widget .topexecinf$i.fb.fsimpl1.subF
    button .topexecinf$i.fb.fsimpl1.subF \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "subF" "Forward Subsumption of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Forward Subsumption "
    
    # build widget .topexecinf$i.fb.fsimpl1.d
    button .topexecinf$i.fb.fsimpl1.d \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "d" "Deletion of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Deletion of Clauses "
    
    # pack widget .topexecinf$i.fb.fsimpl1
    pack append .topexecinf$i.fb.fsimpl1 \
	.topexecinf$i.fb.fsimpl1.s {top frame center fillx} \
	.topexecinf$i.fb.fsimpl1.subF {top frame center fillx} \
	.topexecinf$i.fb.fsimpl1.d {top frame center fillx}
    

    # build widget .topexecinf$i.fb.fsimpl2
    frame .topexecinf$i.fb.fsimpl2 \
	-borderwidth {2} \
	-relief {flat}
    
    # build widget .topexecinf$i.fb.fsimpl2.norm
    button .topexecinf$i.fb.fsimpl2.norm \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "norm" "Normalisation of" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Normalisation "
    
    # build widget .topexecinf$i.fb.fsimpl2.subB
    button .topexecinf$i.fb.fsimpl2.subB \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "subB" "Backward Subsumption from" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Backward Subsumption "
    
    # build widget .topexecinf$i.fb.fsimpl2.n
    button .topexecinf$i.fb.fsimpl2.n \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "n" "New clause:" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " New Clause "
    
    # pack widget .topexecinf$i.fb.fsimpl2
    pack append .topexecinf$i.fb.fsimpl2 \
	.topexecinf$i.fb.fsimpl2.norm {top frame center fillx} \
	.topexecinf$i.fb.fsimpl2.subB {top frame center fillx} \
	.topexecinf$i.fb.fsimpl2.n {top frame center fillx}
    

    # build widget .topexecinf$i.fb.fstat
    frame .topexecinf$i.fb.fstat \
	-borderwidth {2} \
	-relief {flat}
    
    # build widget .topexecinf$i.fb.fstat.fc
    button .topexecinf$i.fb.fstat.fc \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecStat $i fc] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Final Clauses "
    
    # build widget .topexecinf$i.fb.fstat.f1
    frame .topexecinf$i.fb.fstat.f1
    
    # build widget .topexecinf$i.fb.fstat.f1.wfe
    button .topexecinf$i.fb.fstat.f1.wfe \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecStat $i wfe] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Way for the Empty Clause "
    
    # build widget .topexecinf$i.fb.fstat.f1.gs
    button .topexecinf$i.fb.fstat.f1.gs \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecStat $i gs] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Global Statistics "
    
    global selectPatternExec
    # build widget .topexecinf$i.fb.fstat.f1.saveAll
    button .topexecinf$i.fb.fstat.f1.saveAll \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecButtonSave $i "Execution" "" $selectPatternExec ExecSaveExe] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Save All (.exe) "
    
    # pack widget .topexecinf$i.fb.fstat.f1
    pack append .topexecinf$i.fb.fstat.f1 \
	.topexecinf$i.fb.fstat.f1.wfe {top frame center fillx} \
	.topexecinf$i.fb.fstat.f1.gs {top frame center fillx} \
	.topexecinf$i.fb.fstat.f1.saveAll {top frame center fillx} 
    
    # build widget .topexecinf$i.fb.fstat.f2
    frame .topexecinf$i.fb.fstat.f2
    
    # build widget .topexecinf$i.fb.fstat.f2.wfac
    button .topexecinf$i.fb.fstat.f2.wfac \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "wfac" "Clauses:" ""] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Way for Clauses "
    
    global selectPatternStats
    # build widget .topexecinf$i.fb.fstat.f2.saveStats
    button .topexecinf$i.fb.fstat.f2.saveStats \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecButtonSave $i "Statistics" "" $selectPatternStats ExecSaveStat] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Save Statistics (.res) "

    global selectPatternData
    # build widget .topexecinf$i.fb.fstat.f2.saveData
    button .topexecinf$i.fb.fstat.f2.saveData \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecButtonSave $i "Data" "_res" $selectPatternData ExecSaveData] \
	-cursor {hand2} \
	-borderwidth {3} \
	-text " Save as Data (.dat) "
    
    # pack widget .topexecinf$i.fb.fstat.f2
    pack append .topexecinf$i.fb.fstat.f2 \
	.topexecinf$i.fb.fstat.f2.wfac {top frame center fillx} \
	.topexecinf$i.fb.fstat.f2.saveStats {top frame center fillx} \
	.topexecinf$i.fb.fstat.f2.saveData {top frame center fillx} 
    
    # pack widget .topexecinf$i.fb.fstat
    pack append .topexecinf$i.fb.fstat \
	.topexecinf$i.fb.fstat.fc {top frame center fillx} \
	.topexecinf$i.fb.fstat.f1 {left frame center expand fillx} \
	.topexecinf$i.fb.fstat.f2 {right frame center expand fillx} 
    
    # build widget .topexecinf$i.fe
    frame .topexecinf$i.fe \
	-borderwidth {2} \
	-relief {raised}
    
    # build widget .topexecinf$i.fe.f0
    frame .topexecinf$i.fe.f0 \
	-borderwidth {2}
    
    # build widget .topexecinf$i.fe.f1
    frame .topexecinf$i.fe.f1 \
	-borderwidth {2}
    
    # build widget .topexecinf$i.fe.f1.lbl
    label .topexecinf$i.fe.f1.lbl \
	-font $font1 \
	-bg {grey80} \
	-text "" \
	-borderwidth {0}
    
    # build widget .topexecinf$i.fe.f1.e
    entry .topexecinf$i.fe.f1.e \
	-font $font1 \
	-relief {sunken} \
	-borderwidth {0} \
	-width {6} \
	-relief {flat} \
	-state {disabled} \
	-textvariable [list entreeChoice($i,2)]
    # bindings
    bind .topexecinf$i.fe.f1.e <Button-1> [list ExecInfFocus $i 1]
    bind .topexecinf$i.fe.f1.e <Key-Return> [list ExecInfApply1 $i]

    # pack widget .topexecinf$i.fe.f1
    pack append .topexecinf$i.fe.f1 \
	.topexecinf$i.fe.f1.lbl {left frame center} \
	.topexecinf$i.fe.f1.e {left frame center expand fillx}
    
    # build widget .topexecinf$i.fe.f2
    frame .topexecinf$i.fe.f2 \
	-borderwidth {2}

    # build widget .topexecinf$i.fe.f2.lbl1
    label .topexecinf$i.fe.f2.lbl1 \
	-font $font1 \
	-bg {grey80} \
	-text "" \
	-borderwidth {0}
    
    # build widget .topexecinf$i.fe.f2.e1
    entry .topexecinf$i.fe.f2.e1 \
	-font $font1 \
	-relief {sunken} \
	-borderwidth {0} \
	-width {6} \
	-relief {flat} \
	-state {disabled} \
	-textvariable [list entreeChoice($i,2)]
    # bindings
    bind .topexecinf$i.fe.f2.e1 <Button-1> [list ExecInfFocus $i 2]
    bind .topexecinf$i.fe.f2.e1 <Key-Return> [list ExecInfApply1 $i]
    
    # build widget .topexecinf$i.fe.f2.lbl2
    label .topexecinf$i.fe.f2.lbl2 \
	-font $font1 \
	-bg {grey80} \
	-text "" \
	-borderwidth {0}
    
    # build widget .topexecinf$i.fe.f2.e2
    entry .topexecinf$i.fe.f2.e2 \
	-font $font1 \
	-relief {sunken} \
	-borderwidth {0} \
	-width {6} \
	-relief {flat} \
	-state {disabled} \
	-textvariable [list entreeChoice($i,3)]
    # bindings
    bind .topexecinf$i.fe.f2.e2 <Button-1> [list ExecInfFocus $i 3]
    bind .topexecinf$i.fe.f2.e2 <Key-Return> [list ExecInfApply2 $i]
    
    # pack widget .topexecinf$i.fe.f2
    pack append .topexecinf$i.fe.f2 \
	.topexecinf$i.fe.f2.lbl1 {left frame center} \
	.topexecinf$i.fe.f2.e1 {left frame center expand fillx} \
	.topexecinf$i.fe.f2.lbl2 {left frame center} \
	.topexecinf$i.fe.f2.e2 {left frame center expand fillx}
    
    # build widget .topexecinf$i.fe.bApply
    button .topexecinf$i.fe.bApply \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecInfApply $i] \
	-cursor {hand1} \
	-text "Apply"

    # build widget .topexecinf$i.fe.bClear
    button .topexecinf$i.fe.bClear \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command [list ExecManSetInf $i "" "" ""] \
	-cursor {circle} \
	-text "Clear"

    frame .topexecinf$i.f1 -height {5}
    frame .topexecinf$i.f2 -height {5}

    if [list [string compare $ps {Paramodulation}] == 0] {
	.topexecinf$i.fb.finf1.ef configure -state disabled
    } else {
	.topexecinf$i.fb.finf1.ef configure -state normal
    }
}

# Procedure ChangeInfWindow
proc ChangeInfWindow { i } {
    ExecManSetInf $i "" "" ""
    global varTypeManDed
    if [list $varTypeManDed($i) == 1] {
	pack forget .topexecinf$i.fb.fsimpl1
	pack forget .topexecinf$i.fb.fsimpl2
	pack forget .topexecinf$i.fb.fstat
	# pack widget .topexecinf$i.fe
	pack append .topexecinf$i.fe \
	    .topexecinf$i.fe.bClear {right frame center} \
	    .topexecinf$i.fe.bApply {right frame center} \
	    .topexecinf$i.fe.f0 {top frame center expand fillx}
	# pack widget .topexecinf$i.fb
	pack append .topexecinf$i.fb \
	    .topexecinf$i.fb.finf1 {left frame center expand fillx} \
	    .topexecinf$i.fb.finf2 {right frame center expand fillx}
	# pack widget .topexecinf$i
	pack append .topexecinf$i \
	    .topexecinf$i.f0 {top frame center fillx} \
	    .topexecinf$i.f1 {top frame center expand fill} \
	    .topexecinf$i.bClose {bottom frame center fillx} \
	    .topexecinf$i.fe {bottom frame center fillx} \
	    .topexecinf$i.f2 {bottom frame center expand fill} \
	    .topexecinf$i.fb {bottom frame center expand fillx}
    } elseif [list $varTypeManDed($i) == 2] {
	pack forget .topexecinf$i.fb.finf1
	pack forget .topexecinf$i.fb.finf2
	pack forget .topexecinf$i.fb.fstat
	# pack widget .topexecinf$i.fe
	pack append .topexecinf$i.fe \
	    .topexecinf$i.fe.bClear {right frame center} \
	    .topexecinf$i.fe.bApply {right frame center} \
	    .topexecinf$i.fe.f0 {top frame center expand fillx}
	# pack widget .topexecinf$i.fb
	pack append .topexecinf$i.fb \
	    .topexecinf$i.fb.fsimpl1 {left frame center expand fillx} \
	    .topexecinf$i.fb.fsimpl2 {right frame center expand fillx}
	# pack widget .topexecinf$i
	pack append .topexecinf$i \
	    .topexecinf$i.f0 {top frame center fillx} \
	    .topexecinf$i.f1 {top frame center expand fill} \
	    .topexecinf$i.bClose {bottom frame center fillx} \
	    .topexecinf$i.fe {bottom frame center fillx} \
	    .topexecinf$i.f2 {bottom frame center expand fill} \
	    .topexecinf$i.fb {bottom frame center expand fillx}
    } else {
	pack forget .topexecinf$i.fb.finf1
	pack forget .topexecinf$i.fb.finf2
	pack forget .topexecinf$i.fb.fsimpl1
	pack forget .topexecinf$i.fb.fsimpl2
	# pack widget .topexecinf$i.fe
	pack append .topexecinf$i.fe \
	    .topexecinf$i.fe.bClear {right frame center} \
	    .topexecinf$i.fe.bApply {right frame center} \
	    .topexecinf$i.fe.f0 {top frame center expand fillx}
	# pack widget .topexecinf$i.fb
	pack append .topexecinf$i.fb \
	    .topexecinf$i.fb.fstat {bottom frame center expand fillx}
	# pack widget .topexecinf$i
	pack append .topexecinf$i \
	    .topexecinf$i.f0 {top frame center fillx} \
	    .topexecinf$i.f1 {top frame center expand fill} \
	    .topexecinf$i.bClose {bottom frame center fillx} \
	    .topexecinf$i.fe {bottom frame center fillx} \
	    .topexecinf$i.f2 {bottom frame center expand fill} \
	    .topexecinf$i.fb {bottom frame center expand fillx}
    }
}
