##############################################################################
# Construction de la fenetre .topsavefile
##############################################################################

# procedure to show window ShowWindow.topsavefile
proc ShowWindow.topsavefile { args} {
    # xf ignore me 7
    
    # build widget .topsavefile
    if {"[info procs XFEdit]" != ""} {
	catch "XFDestroy .topsavefile"
    } {
	catch "destroy .topsavefile"
    }
    toplevel .topsavefile 
    
    # Window manager configurations
    wm positionfrom .topsavefile ""
    wm sizefrom .topsavefile ""
    wm minsize .topsavefile 10 10
    wm title .topsavefile {daTac: Save Example}
    
    global {font1}
    
    # bindings
    bind .topsavefile <Enter> {focus .topsavefile.feFile.f2.e}
    
    # build widget .topsavefile.bCancel
    button .topsavefile.bCancel \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {DestroyWindow .topsavefile} \
	-cursor {circle} \
	-text {Cancel}
    
    # build widget .topsavefile.bOk
    button .topsavefile.bOk \
	-font $font1 \
	-bg {grey95} \
	-activebackground {grey95} \
	-activeforeground {grey5} \
	-command {
	    global entreeSaveFile ; global entreeSavePath
	    set entreeSaveFile [string trim $entreeSaveFile]
	    set entreeSavePath [string trim $entreeSavePath]
	    if {$entreeSaveFile != "" && $entreeSavePath != ""} {
		.topsavefile.bOk configure -state disabled
		.topsavefile.bCancel configure -state disabled
		global selectPatternData
		set entreeSaveFile [AddExtension $entreeSaveFile [file extension $selectPatternData]]
		set entreeSavePath [AddSlash $entreeSavePath]
		# Sauvegarder les donnees dans un fichier
		if {[SaveDataToFile "$entreeSavePath$entreeSaveFile"] == 1} {
		    set varFilename $entreeSaveFile
		    set varPathname $entreeSavePath
		    DestroyWindow .topsavefile
		}
	    }
	} \
	-cursor {hand1} \
	-text {Ok}
    
    # build widget .topsavefile.feFile
    frame .topsavefile.feFile \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .topsavefile.feFile {Filename:} entreeSaveFile
    
    # bindings
    bind .topsavefile.feFile.f2.e <Key-Return> {.topsavefile.bOk flash
	.topsavefile.bOk invoke}
    bind .topsavefile.feFile.f2.e <Key-Up> {focus .topsavefile.fePath.f2.e}
    
    # build widget .topsavefile.fePath
    frame .topsavefile.fePath \
	-borderwidth {2} \
	-relief {raised}
    
    ScrolledEntry .topsavefile.fePath {Pathname:} entreeSavePath -width {30}

    # bindings
    bind .topsavefile.fePath.f2.e <Key-Return> {
	global entreeSavePath ; global entreeSaveFile
	global varSavePath
	# set entreeSaveFile ""
	set entreeSavePath [string trim $entreeSavePath]
	if {$entreeSavePath == ""} {
	    set entreeSavePath $varSavePath
	} else {
	    set entreeSavePath [SearchDirectory [AddSlash $entreeSavePath]]
	    if {$entreeSavePath == ""} {
		set entreeSavePath $varSavePath
	    } else {
		set varSavePath $entreeSavePath
	    }
	}
	global selectPatternData
	LsToListbox  $entreeSavePath $selectPatternData .topsavefile.flb.list
	.topsavefile.fePath.f2.e xview [expr [string length $entreeSavePath]-28]
    }
    bind .topsavefile.fePath.f2.e <Key-Down> {focus .topsavefile.feFile.f2.e}
    
    # build widget .topsavefile.flb
    frame .topsavefile.flb

    ScrolledListbox2 .topsavefile.flb
    
    # bindings
    bind .topsavefile.flb.list <B1-Motion> {%W selection anchor [%W nearest %y]}
    bind .topsavefile.flb.list <Button-1> {%W selection anchor [%W nearest %y]}
    bind .topsavefile.flb.list <ButtonRelease-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global varSavePath ; global entreeSavePath ; global entreeSaveFile
	    set entreeSavePath $varSavePath
	    
	    set selection [%W get $i]
	    if {$selection != "../" && [file isfile $entreeSavePath$selection] == 1} {
		set entreeSaveFile $selection
		.topsavefile.feFile.f2.e xview [expr [string length $entreeSaveFile]-28]
	    } else {
		# set entreeSaveFile ""
		.topsavefile.feFile.f2.e xview 0
	    }
	    catch "unset selection"
	}
	catch "unset i"}
    bind .topsavefile.flb.list <Double-Button-1> {
	%W selection anchor [%W nearest %y]
	set i [%W curselection]
	if {$i != ""} {
	    global varSavePath ; global entreeSavePath ; global entreeSaveFile
	    set entreeSavePath $varSavePath
	    
	    global selectPatternData
	    set selection [%W get $i]
	    if {$selection == "../"} {
		# set entreeSaveFile ""
#		set entreeSavePath [AddSlash [file dirname [file dirname $entreeSavePath]]]
		set entreeSavePath [AddSlash [file dirname $entreeSavePath]]
		LsToListbox $entreeSavePath $selectPatternData .topsavefile.flb.list
		.topsavefile.fePath.f2.e xview [expr [string length $entreeSavePath]-28]
	    } else {
		if {[file isfile $entreeSavePath$selection] == 1} {
		    set entreeSaveFile $selection
		    .topsavefile.bOk flash
		    .topsavefile.bOk invoke
		} else { # $selection est un repertoire
		    # set entreeSaveFile ""
		    set entreeSavePath $entreeSavePath$selection
		    LsToListbox $entreeSavePath $selectPatternData .topsavefile.flb.list
		    .topsavefile.fePath.f2.e xview [expr [string length $entreeSavePath]-28]
		}
	    }
	    catch "unset selection"
	    set varSavePath $entreeSavePath
	}
	catch "unset i"}
    
    # build widget .topsavefile.lbl
    label .topsavefile.lbl \
	-font $font1 \
	-bg {grey80} \
	-relief {raised} \
	-text {Select a file to save data}
    
    # pack widget .topsavefile
    pack append .topsavefile \
	.topsavefile.lbl {top frame center fill} \
	.topsavefile.flb {top frame center expand fill} \
	.topsavefile.fePath {top frame center fill} \
	.topsavefile.feFile {top frame center fill} \
	.topsavefile.bCancel {left frame center expand fill} \
	.topsavefile.bOk {left frame center expand fill} 
    
    if {"[info procs XFEdit]" != ""} {
	catch "XFMiscBindWidgetTree .topsavefile"
	after 2 "catch {XFEditSetShowWindows}"
    }
}
